<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

<template>
  <div
    class="modal animated fadeInRight s--modal s--modal-import s--modal-right"
    data-backdrop="static"
    data-keyboard="false"
    id="importCustomer"
  >
    <div class="modal-dialog modal-dialog-centered" style="max-width: 100%">
      <div class="modal-content">
        <div class="modal-header d-flex align-items-center position-relative">
          <div
            class="w-100"
            style="max-width: 1000px;margin: 0 auto; display: flex;justify-content: center;"
          >
            <div
              class="m-wizard m-wizard--2 m-wizard--success m-wizard--step-first s--wizard_progress"
              id="m_wizard"
              style="width: 100%; float:left;"
            >
              <div class="m-portlet__padding-x"></div>

              <div
                class="m-wizard__head m-portlet__padding-x"
                style="margin: 40px auto 20px; max-width: 1000px;"
              >
                <div class="m-wizard__progress">
                  <div class="progress">
                    <div
                      class="progress-bar"
                      role="progressbar"
                      aria-valuenow="100"
                      aria-valuemin="0"
                      aria-valuemax="100"
                      :style="{ width: (customerImportIsStep2 && !customerImportIsSuccess)  ? '50%' : customerImportIsSuccess ? '100%' : 0  }"
                    ></div>
                  </div>
                </div>

                <div class="m-wizard__nav">
                  <div class="m-wizard__steps">
                    <div
                      style="width: 25%;"
                      class="m-wizard__step"
                      m-wizard-target="m_wizard_customer_import_step_1"
                      :class="{'m-wizard__step--current': !customerImportIsStep2, 'm-wizard__step--done': customerImportIsStep2}"
                    >
                      <span class="m-wizard__step-number">
                        <span class="step-number">
                          <i class="icon icon-upload" style="font-size: 12px !important;"></i>
                        </span>
                      </span>
                      <div class="m-wizard__step-info">
                        <div class="m-wizard__step-title">
                          Bước 1:
                          <strong>Upload File</strong>
                        </div>
                      </div>
                    </div>
                    <div
                      style="width: 25%;"
                      class="m-wizard__step"
                      m-wizard-target="m_wizard_customer_import_step_2"
                      :class="{'m-wizard__step--current': customerImportIsStep2 && !customerImportIsSuccess && !customerImportIsLastStep && customerImportErrorStatus != 2, 'm-wizard__step--done': customerImportIsLastStep || customerImportIsSuccess || customerImportErrorStatus == 2 }"
                    >
                      <span class="m-wizard__step-number">
                        <span class="step-number">
                          <i class="la la-repeat"></i>
                        </span>
                      </span>
                      <div class="m-wizard__step-info">
                        <div class="m-wizard__step-title">
                          Bước 2:
                          <strong>Kiểm tra dữ liệu</strong>
                        </div>
                      </div>
                    </div>

                    <div
                      style="width: 25%;"
                      class="m-wizard__step"
                      m-wizard-target="m_wizard_customer_import_step_3"
                      :class="{'m-wizard__step--done': customerImportIsSuccess }"
                    >
                      <span class="m-wizard__step-number">
                        <span class="step-number">
                          <i class="la la-check"></i>
                        </span>
                      </span>
                      <div class="m-wizard__step-info">
                        <div class="m-wizard__step-title">
                          Bước 3:
                          <strong>Hoàn thành</strong>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <button
              v-if="customerImportIsSuccess"
              type="button"
              class="close"
              data-dismiss="modal"
              aria-label="Close"
            >
              <span aria-hidden="true">
                <i class="la la-times"></i>
              </span>
            </button>
          </div>
        </div>
        <div
          class="modal-body"
          data-scrollable="true"
          data-scrollbar-shown="true"
          :class="{'m-loader m-loader--primary m-loader--center is-loader m-loader--lg' : customerImportIsLoader}"
          style="display: flex; align-items: center;"
        >
          <div
            class="m-wizard m-wizard--2 m-wizard--success m-wizard--step-first s--wizard_progress"
            id="m_wizard"
          >
            <div class="m-portlet__padding-x"></div>

            <div class="m-wizard__form">
              <div
                :class="{ 'm-wizard__form-step--current': !customerImportIsStep2 }"
                class="m-wizard__form-step s-import-step"
                id="m_wizard_customer_import_step_1"
              >
                <div class="s-content text-center" style="max-width: 600px; margin: 0 auto;">
                  <div class="row">
                    <div class="col-md-12">
                      <h2 style="color: #444F78; margin-bottom: 30px;">Import danh sách khách hàng</h2>
                    </div>
                    <div class="col-md-6" style="margin: 0 auto">
                      <label
                        class="w-100"
                        style="padding: 20px; border-radius: 4px; border: 1px solid rgb(233, 236, 239);"
                      >
                        <span class="m-option__control">
                          <label
                            class="m-radio m-radio--primary pl-0"
                            style="font-size:15px; font-weight: 500; pointer-events: none;"
                          >
                            <input type="radio" v-model="customerImportType" value="1" /> Thêm mới hàng
                            loạt
                          </label>
                          <div class="s-note">
                            <i>(Import danh sách khách hàng có sẵn)</i>
                          </div>
                          <div class="message m--margin-top-5">
                            <a
                              class="m-link m-link--primary nt-link"
                              href="javascript:;"
                              @click.prevent="downloadFileDefault()"
                            >
                              <i class="icon icon-download"></i>&nbsp;
                              Download file excel mẫu
                            </a>
                          </div>
                        </span>
                      </label>
                    </div>
                  </div>

                  <div class="input-file nt-input-file-primary m--margin-top-15 d-inline-block">
                    <label>
                      <i class="icon icon-upload"></i>&nbsp; Upload file excel
                    </label>
                    <input
                      accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
                      title=" "
                      type="file"
                      @change.prevent="customerUploadOnFileChange($event)"
                      class="customer-input-file"
                      name="upload_file"
                      ref="uploadFile"
                    />
                    <div v-if="customerFile && customerFile.name" class="m--margin-top-5">
                      {{
                      customerFile.name }}
                    </div>
                    <div
                      v-if="(customerFile && customerFile.type &&  customerFile.type != 'xlsx')"
                      class="m--margin-top-5 text-danger"
                    >{{ messageError }}</div>
                    <div
                      class="form-control-feedback m--font-danger"
                      v-if="isImportMaxSize"
                    >{{ messageError }}</div>
                    <div
                      v-else-if="isImportMaxRow"
                      class="m--margin-top-5 text-danger"
                    >{{ messageError }}</div>
                    <div v-else-if="incorrectFileFormat" class="m--margin-top-5 text-danger">
                      <span v-html="messageError"></span>
                    </div>
                    <div
                      v-else-if="isImportMinRow"
                      class="m--margin-top-5 text-danger"
                    >{{ messageError }}</div>
                  </div>
                </div>
              </div>

              <div
                :class="{ 'm-wizard__form-step--current': customerImportIsStep2 && !customerImportIsSuccess }"
                class="m-wizard__form-step s-import-step"
                id="m_wizard_customer_import_step_2"
              >
                <div class="s-content">
                  <div
                    v-if="customerImportErrorStatus == 1"
                    class
                    style="max-width: 600px;margin: 0 auto;"
                  >
                    <h5 class="m--margin-bottom-15 text-center">
                      Kết quả đạt
                      <span class="m--font-success">{{ countRowSuccess }}</span>/
                      <span>{{ totalRow }} khách hàng</span>
                    </h5>

                    <div class="row" style="margin-top:40px;">
                      <div class="col-md-6">
                        <label
                          class="s--cursor-pointer w-100"
                          :class="{ 'is-border-primary' : customerImportCheckDataResult == 1}"
                          style="padding: 20px; border-radius: 4px; border: 1px solid rgb(233, 236, 239);"
                        >
                          <span class="m-option__control">
                            <span
                              class="m-radio m-radio--primary"
                              style="color: #212529;margin-bottom:0;font-weight: 500;font-size:15px;"
                            >
                              <input
                                @change="customerImportCheckDataResultFunction()"
                                type="radio"
                                v-model="customerImportCheckDataResult"
                                value="1"
                              />
                              Tiếp tục import dữ liệu đạt
                              <span></span>
                            </span>
                          </span>
                        </label>
                      </div>
                      <div class="col-md-6">
                        <label
                          class="s--cursor-pointer w-100"
                          :class="{ 'is-border-primary' : customerImportCheckDataResult == 2}"
                          style="padding: 20px; border-radius: 4px; border: 1px solid rgb(233, 236, 239);"
                        >
                          <span class="m-option__control">
                            <span
                              class="m-radio m-radio--primary"
                              style="color: #212529;margin-bottom:0;font-weight: 500;font-size:15px;"
                            >
                              <input
                                @change="customerImportCheckDataResultFunction()"
                                type="radio"
                                v-model="customerImportCheckDataResult"
                                value="2"
                              />
                              Chỉnh sửa file và import lại
                              <span></span>
                            </span>
                          </span>
                        </label>
                      </div>
                      <div
                        style="max-width: 440px; margin: 30px auto 0; background-color: #f2f2f2; padding: 20px; border-radius: 4px;"
                      >
                        <h5
                          class
                          style="font-size: 15px;margin-bottom: 10px;"
                        >Bạn vui lòng làm theo bước sau:</h5>
                        <ul class="list-unstyled m-0" v-if="customerImportCheckDataResult == 1">
                          <li style="margin-bottom: 5px;">
                            Bước 1:
                            <div class="message m--margin-top-5" @click="downloadFileExcelError()">
                              <a
                                class="m-link m-link--primary nt-link"
                                href="javascript:;"
                                @click.prevent="customerImportSkipping = 1"
                              >
                                <i class="icon icon-download"></i>&nbsp;
                                Download file kết
                                quả
                              </a>&nbsp;(Có mô tả thông tin không đạt).
                            </div>
                          </li>
                          <li>Bước 2: Tích button "Tiếp theo" để hoàn thành việc import.</li>
                        </ul>

                        <ul class="list-unstyled m-0" v-if="customerImportCheckDataResult == 2">
                          <li style="margin-bottom: 5px;">
                            Bước 1:
                            <div class="message m--margin-top-5" @click="downloadFileExcelError()">
                              <a
                                class="m-link m-link--primary nt-link"
                                href="javascript:;"
                                @click.prevent="customerImportSkipping = 1"
                              >
                                <i class="icon icon-download"></i>&nbsp;
                                Download file kết
                                quả
                              </a>&nbsp;(Có mô tả thông tin không đạt).
                            </div>
                          </li>
                          <li
                            style="margin-bottom: 5px;"
                          >Bước 2: Sửa thông tin không đạt trong file excel.</li>

                          <li style="margin-bottom: 5px;">
                            Bước 3:
                            <div
                              class="input-file input-file-primary d-inline-block"
                              :class="{'s-disabled-opacity': !customerImportSkipping}"
                            >
                              <label class="nt-link"
                                style="    padding: 0;
                    background-color: transparent;
                    height: auto;
                    line-height: 1.5;"
                              >
                                <i class="icon icon-upload"></i> Upload lại file excel đã sửa.
                              </label>
                              <input
                                style="left: -68px; right: 0; width: calc(100% + 68px); "
                                :disabled="!customerImportSkipping"
                                :class="{'s--cursor-not-allow': !customerImportSkipping}"
                                accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
                                title=" "
                                type="file"
                                name="upload_file"
                                ref="uploadFileOne"
                                @change.prevent="customerUploadOnFileEdit($event)"
                                class="customer-input-file"
                              />
                            </div>
                            <div
                              v-if="customerFile && customerFile.name && customerUploadOnFileChangeEdit"
                              class="m--margin-top-5"
                              style="margin-left: 47px;    color: #747688;"
                            >
                              {{
                              customerFile.name }}
                            </div>
                          </li>
                          <li>Bước 4: Tích button "Kiểm tra lại" và xem kết quả kiểm tra mới.</li>
                        </ul>
                      </div>
                    </div>
                  </div>

                  <div
                    v-if="customerImportErrorStatus == 2"
                    class="text-center"
                    style="max-width: 600px;margin: 0 auto;"
                  >
                    <h5 class="m--margin-bottom-15">
                      Kết quả đạt
                      <span class="m--font-success">{{ countRowSuccess }}</span>/
                      <span>{{ totalRow }}</span>
                      khách hàng
                    </h5>

                    <div class="m--font-success">
                      <i style="font-size: 60px" class="la la-check"></i>
                    </div>
                  </div>

                  <div
                    v-if="customerImportErrorStatus == 3"
                    class
                    style="max-width: 600px;margin: 0 auto;"
                  >
                    <h5 class="m--margin-bottom-15 text-center">
                      Kết quả đạt
                      <span class="m--font-danger">0</span>/
                      <span>{{ totalRow }} khách hàng</span>
                    </h5>
                    <div
                      class="text-left"
                      style="max-width: 440px;
                    margin: 20px auto 0;
                    background-color: #f2f2f2;
                    padding: 20px;
                    border-radius: 4px;"
                    >
                      <h5 class style="font-size: 15px;margin-bottom: 10px;">Gợi ý:</h5>
                      <ul class="list-unstyled m-0">
                        <li style="margin-bottom: 5px;">
                          Bước 1:
                          <div class="message m--margin-top-5" @click="downloadFileExcelError()">
                            <a
                              class="m-link m-link--primary nt-link"
                              href="javascript:;"
                              @click.prevent="customerImportSkipping = 1"
                            >
                              <i class="icon icon-download"></i>&nbsp;
                              Download file kết
                              quả
                            </a>&nbsp;(Có mô tả thông tin không đạt).
                          </div>
                        </li>
                        <li
                          style="margin-bottom: 5px;"
                        >Bước 2: Sửa các thông tin không đạt trong file excel.</li>
                        <li>
                          Bước 3:
                          <div
                            class="input-file input-file-primary d-inline-block"
                            :class="{'s-disabled-opacity': !customerImportSkipping}"
                          >
                            <label class="nt-link"
                              style="padding: 0;
                    background-color: transparent;
                    height: auto;
                    line-height: 1.5;"
                            >
                              <i class="icon icon-upload"></i> Upload lại file excel đã sửa.
                            </label>
                            <input
                              style="left: -68px; right: 0; width: calc(100% + 68px); "
                              :disabled="!customerImportSkipping"
                              :class="{'s--cursor-not-allow': !customerImportSkipping}"
                              accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
                              title=" "
                              type="file"
                              name="upload_file"
                              ref="uploadFileTwo"
                              @change.prevent="customerUploadOnFileEdit($event)"
                              class="customer-input-file"
                            />
                          </div>
                          <div
                            v-if="customerFile && customerFile.name && customerUploadOnFileChangeEdit"
                            class="m--margin-top-5"
                            style="margin-left: 47px; color: #747688;"
                          >{{ customerFile.name }}</div>
                        </li>
                      </ul>
                    </div>
                  </div>
                </div>
              </div>

              <div
                :class="{ 'm-wizard__form-step--current': customerImportIsSuccess }"
                class="m-wizard__form-step"
                id="m_wizard_customer_import_step_3"
              >
                <div
                  style="    max-width: 600px;
                    margin: 0 auto;
                    text-align: center;"
                >
                  <div class="s--modal-message">
                    <template v-if="isServerInsertData">
                      <div class="s--modal-icon">
                        <i class="la la-check m--font-success" style="font-size: 40px;"></i>
                      </div>
                      <h5 class="s--modal-title" style="font-size: 20px;">
                        Bạn đã
                        <span v-if="customerImportType == 1">thêm mới</span>
                        <span v-if="customerImportType == 2">cập nhật</span> thành công
                        <template v-if="countRowSuccess">{{ countRowSuccess }}</template>
                        khách hàng.
                      </h5>

                      <div class="m--margin-top-25">
                        <button
                          @click.prevent="customerUploadSuccessCloseModal()"
                          class="nt-button nt-button-primary m-auto nt-button-pill"
                        >
                          <i style="font-size:14px;" class="la la-angle-left"></i>
                          Trở về màn hình danh sách khách hàng
                        </button>
                      </div>
                    </template>
                    <template v-else>
                      <div class="s--modal-icon">
                        <i class="la la-close m--font-danger" style="font-size: 40px;"></i>
                      </div>
                      <h5
                        class="s--modal-title"
                        style="font-size: 20px;"
                      >Đường truyền có lỗi, vui lòng tải lại trang</h5>
                    </template>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div class="modal-footer" v-if="!customerImportIsSuccess">
          <div
            class="w-100 page-list-actions"
            style="max-width: 1000px; margin: 0 auto; display: flex; align-items: center;"
          >
            <div class="left-action">
              <div class="float-left text-left" style="width: 50%;">
                <button
                  v-if="customerImportIsStep2"
                  @click.prevent="customerUploadBackStep()"
                  :disabled="customerImportIsLoader"
                  type="button"
                  class="nt-button nt-button-secondary mr-2 d-inline-block"
                >
                  <i class="la la-angle-left" style="font-size:14px;"></i>Trở lại
                </button>
              </div>

              <div style="width: 50%; float: left; text-align: center;">
                Bước:
                <strong>
                  <span v-if=" customerImportIsStep2 && !customerImportIsSuccess">2</span>
                  <span v-else-if="customerImportIsSuccess">3</span>
                  <span v-else>1</span>/3
                </strong>
              </div>
            </div>

            <div
              class="float-left text-right right-action"
              style=" display: flex;justify-content: flex-end;"
            >
              <button
                data-dismiss="modal"
                @click.prevent="customerUploadCloseModal()"
                :disabled="customerImportIsLoader"
                type="button"
                class="mr-2 nt-button nt-button-secondary d-inline-block"
                :class="{  'nt-button-disabled': customerImportIsLoader  }"
              >Hủy bỏ</button>
              <!-- Next Step 2 -->
              <button
                v-if="!customerImportErrorStatus"
                :class="{'nt-button-disabled': customerImportIsLoader || isDisabled || !customerFile}"
                :disabled="customerImportIsLoader || isDisabled || !customerFile"
                @click.prevent="customerImportStep2()"
                type="submit"
                class="nt-button nt-button-warning float-right mr-0"
              >
                Tiếp theo
                <i style="font-size:14px;" class="la la-angle-right"></i>
              </button>

              <!-- Next Step 3 -->
              <button
                v-if="customerImportErrorStatus == 1 && customerImportCheckDataResult == 1"
                :class="{'nt-button-disabled': !customerImportSkipping}"
                :disabled="!customerImportSkipping"
                @click.prevent="customerImportFile()"
                type="submit"
                class="nt-button nt-button-warning float-right mr-0"
              >
                Tiếp theo
                <i style="font-size:14px;" class="la la-angle-right"></i>
              </button>
              <button
                v-if="customerImportErrorStatus == 1 && customerImportCheckDataResult == 2 || customerImportErrorStatus == 3"
                :class="{'nt-button-disabled': !customerImportSkipping }"
                :disabled="!customerImportSkipping"
                @click.prevent="customerUploadOnFileEditSubmit()"
                type="submit"
                class="nt-button nt-button-warning float-right mr-0"
              >Kiểm tra lại</button>

              <button
                v-if="customerImportErrorStatus == 2"
                @click.prevent="customerImportFile()"
                type="submit"
                class="nt-button nt-button-warning"
              >
                Tiếp theo
                <i style="font-size:14px;" class="la la-angle-right float-right mr-0"></i>
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
